package com.persagy.iottransfer.communication.netty.codec;

import com.persagy.iottransfer.communication.entity.Packet;
import com.persagy.iottransfer.communication.util.MyEncoder;
import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.MessageToByteEncoder;

public class NettyPacketEncoder extends MessageToByteEncoder<Packet> {
    String ip;
    int port;
    String encoding;
    String aes_password;
    boolean compress = false;

    boolean separate = false;
    boolean separateBytes = false;
    byte prefix;
    byte suffix;
    byte[] prefixBytes;
    byte[] suffixBytes;

    MyEncoder encoder;

    public NettyPacketEncoder(String ip, int port, String encoding, String aes_password, boolean compress) {
        this.ip = ip;
        this.port = port;

        this.encoding = encoding;
        this.compress = compress;

        this.separate = false;

        this.encoder = new MyEncoder(this.ip, this.port, this.encoding, this.aes_password, this.compress, this.separate,
                this.separateBytes, this.prefix, this.suffix, this.prefixBytes, this.suffixBytes);
    }

    public NettyPacketEncoder(String ip, int port, String encoding, String aes_password, boolean compress, byte prefix,
                              byte suffix) {
        this.ip = ip;
        this.port = port;

        this.encoding = encoding;
        this.compress = compress;

        this.separate = true;
        this.separateBytes = false;
        this.prefix = prefix;
        this.suffix = suffix;

        this.encoder = new MyEncoder(this.ip, this.port, this.encoding, this.aes_password, this.compress, this.separate,
                this.separateBytes, this.prefix, this.suffix, this.prefixBytes, this.suffixBytes);
    }

    public NettyPacketEncoder(String ip, int port, String encoding, String aes_password, boolean compress,
                              byte[] prefixBytes, byte[] suffixBytes) {
        this.ip = ip;
        this.port = port;

        this.encoding = encoding;
        this.aes_password = aes_password;
        this.compress = compress;

        this.separate = true;
        this.separateBytes = true;
        this.prefixBytes = prefixBytes;
        this.suffixBytes = suffixBytes;

        this.encoder = new MyEncoder(this.ip, this.port, this.encoding, this.aes_password, this.compress, this.separate,
                this.separateBytes, this.prefix, this.suffix, this.prefixBytes, this.suffixBytes);
    }

    @Override
    protected void encode(ChannelHandlerContext ctx, Packet message, ByteBuf out) throws Exception {
        Packet request = message;
        byte[] comm_bytes = this.encoder.encode(request);
        out.writeBytes(comm_bytes);
    }
}
